UIPackage
Menu

Framework

Change language

Boilerplate repo

Sunburst Chart

sunburst-chartui

Sunburst wrapper around Apache ECharts. Concentric-ring hierarchical share visualization — pairs naturally with treemap for comparison.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/sunburst-chart.json
Named registry:npx shadcn-vue@latest add @uipkge/sunburst-chartInstalls to:app/components/ui/charts/sunburst-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
data

Hierarchical data — top-level array, each node has `name`, optional `value`, optional `children`.

SunNode[]required
heightnumber | string360optional
radius

Inner / outer radius as percentages of the smaller container side. Default `['12%', '90%']`.

[string, string]() => ['12%'optional
optionanyoptional
classstringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

SunNode
interface SunNode {
  name: string
  value?: number
  children?: SunNode[]
}

npm dependencies

Used by

Files installed (3)

  • app/components/ui/charts/sunburst-chart/SunburstChart.vue2.3 kB
    <script setup lang="ts">
    import { computed } from 'vue'
    import { use } from 'echarts/core'
    import { CanvasRenderer } from 'echarts/renderers'
    import { SunburstChart as EChartsSunburstChart } from 'echarts/charts'
    import { TooltipComponent } from 'echarts/components'
    import VChart from 'vue-echarts'
    import { cn } from '@/lib/utils'
    import { chartColors, chartTextColor, chartTooltipBg, chartTooltipBorder, chartTooltipText } from '../useChartTheme'
    
    use([CanvasRenderer, EChartsSunburstChart, TooltipComponent])
    
    interface SunNode {
      name: string
      value?: number
      children?: SunNode[]
    }
    
    interface Props {
      /** Hierarchical data — top-level array, each node has `name`, optional `value`, optional `children`. */
      data: SunNode[]
      height?: number | string
      /** Inner / outer radius as percentages of the smaller container side. Default `['12%', '90%']`. */
      radius?: [string, string]
      option?: any
      class?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    const props = withDefaults(defineProps<Props>(), {
      height: 360,
      radius: () => ['12%', '90%'] as [string, string],
    })
    
    const mergedOption = computed(() => {
      const series = [
        {
          type: 'sunburst',
          radius: props.radius,
          data: props.data,
          label: { rotate: 'radial' as const, fontSize: 11 },
          itemStyle: { borderColor: chartTextColor.value, borderWidth: 1 },
          emphasis: { focus: 'ancestor' as const },
        },
      ]
    
      const userOption: any = props.option ?? {}
      const { series: userSeries, ...userRest } = userOption
      const mergedSeries = Array.isArray(userSeries) ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) })) : series
    
      return {
        color: chartColors.value,
        tooltip: {
          trigger: 'item',
          backgroundColor: chartTooltipBg.value,
          borderColor: chartTooltipBorder.value,
          textStyle: { color: chartTooltipText.value, fontSize: 12 },
        },
        series: mergedSeries,
        ...userRest,
      }
    })
    </script>
    
    <template>
      <div
        role="img"
        tabindex="0"
        :aria-label="ariaLabel || 'Chart'"
        :style="{ height: /^\d+$/.test(String(height)) ? `${height}px` : String(height) }"
        :class="cn('focus-visible:ring-ring w-full focus-visible:ring-2 focus-visible:outline-none', props.class)"
      >
        <VChart :option="mergedOption" :autoresize="true" class="size-full" />
      </div>
    </template>
    
  • app/components/ui/charts/sunburst-chart/index.ts0.1 kB
  • app/components/ui/charts/useChartTheme.ts8.2 kB

Raw manifest:https://uipkge.dev/r/vue/sunburst-chart.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Sunburst Chart

sunburst-chartui

React mirror of @uipkge/sunburst-chart — see the Vue registry item for the canonical description.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/sunburst-chart.json
Named registry:npx shadcn@latest add @uipkge-react/sunburst-chartInstalls to:components/ui/charts/sunburst-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
data

Hierarchical data — top-level array, each node has `name`, optional `value`, optional `children`.

SunNode[]required
heightnumber | string360optional
radius

Inner / outer radius as percentages of the smaller container side. Default `['12%', '90%']`.

[string, string]optional
optionanyoptional
classNamestringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

SunNode
interface SunNode {
  name: string
  value?: number
  children?: SunNode[]
}
ChartTheme
interface ChartTheme {
  colors: string[]
  textColor: string
  axisColor: string
  splitLineColor: string
  tooltipBg: string
  tooltipBorder: string
  tooltipText: string
  bgColor: string
  /** The app's accent, for the one highlighted element on a chart or map —
   *  a selected route, a focused bar. Category series keep using `colors`. */
  accentColor: string
  /** Out-of-bounds / failure colour for charts that encode good vs bad
   *  rather than a category — control limits, error series. CSS-level marks
   *  can use `var(--destructive)` directly; this exists because ECharts needs
   *  a resolved colour string on the canvas. */
  dangerColor: string
}

npm dependencies

Used by

Files installed (4)

  • components/ui/charts/sunburst-chart/SunburstChart.tsx2.1 kB
    'use client'
    
    import * as React from 'react'
    import ReactECharts from 'echarts-for-react/esm/core'
    import { ChartFrame, EChart } from '../shared'
    import { useChartTheme } from '../useChartTheme'
    
    // SunburstChart
    // ─────────────────────────────────────────────────────────────────────────
    
    interface SunNode {
      name: string
      value?: number
      children?: SunNode[]
    }
    
    export interface SunburstChartProps {
      /** Hierarchical data — top-level array, each node has `name`, optional `value`, optional `children`. */
      data: SunNode[]
      height?: number | string
      /** Inner / outer radius as percentages of the smaller container side. Default `['12%', '90%']`. */
      radius?: [string, string]
      option?: any
      className?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    export const SunburstChart = React.forwardRef<HTMLDivElement, SunburstChartProps>(
      ({ data, height = 360, radius = ['12%', '90%'], option, className, ariaLabel }, ref) => {
        const theme = useChartTheme()
    
        const mergedOption = React.useMemo(() => {
          const series = [
            {
              type: 'sunburst',
              radius,
              data,
              label: { rotate: 'radial' as const, fontSize: 11 },
              itemStyle: { borderColor: '#fff', borderWidth: 1 },
              emphasis: { focus: 'ancestor' as const },
            },
          ]
    
          const userOption: any = option ?? {}
          const { series: userSeries, ...userRest } = userOption
          const mergedSeries = Array.isArray(userSeries)
            ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) }))
            : series
    
          return {
            color: theme.colors,
            tooltip: {
              trigger: 'item',
              backgroundColor: theme.tooltipBg,
              borderColor: theme.tooltipBorder,
              textStyle: { color: theme.tooltipText, fontSize: 12 },
            },
            series: mergedSeries,
            ...userRest,
          }
        }, [data, radius, option, theme])
    
        return (
          <ChartFrame ref={ref} height={height} className={className} ariaLabel={ariaLabel}>
            <EChart option={mergedOption} />
          </ChartFrame>
        )
      },
    )
    SunburstChart.displayName = 'SunburstChart'
    
  • components/ui/charts/sunburst-chart/index.ts0.1 kB
  • components/ui/charts/useChartTheme.ts8.7 kB
  • components/ui/charts/shared.tsx3.7 kB

Raw manifest:https://uipkge.dev/r/react/sunburst-chart.json